%Dette skriptet beregner absorpsjonsfaktor for et system bestende
%av en mikroslissepanel et luftrom og en spaltepanel som skal representere
%en kavitet som har lekkasjer.
%
clear all;
close all;

saveres=false;

%Deklarerer fysiske parametere
rhoair=1.2;%lufttetthet
cair=344;%lydhastighet i luft

f=[50,63,80,100,125,160,200,250,315,400,500,630,800,1000,1250,1600,2000,2500,3150,4000,5000];%frekvensvektor
w=2.*pi.*f;%vinkelfrekvensvektor
k=w./cair;%blgetall

t=1/1000;%paneltykkelse i mm

%Undersk utviklingen som funksjon av lekkasje, eller se p enkeltlekkasje.
% for lekkasje=1:15:100,%lekkasje i mm
alphaphi2=0;
alphaALT2=0;
   a=1;
    if a==1,
        lekkasje=100;
    
bredde2=lekkasje/1000;%lekkasjebredde i mm
bredde=0.18/1000;
B=20/1000;%senter-senter avstand mikroslisse
B2=1000/1000;%senter-senter avstand lekkasje

t2=1/1000;%lekkasjetykkelse

d=100/1000;%foringsdybde

mu=17.9*10^-6;%visksitetskoeffisient
Zair=rhoair*cair;%karakteristisk impedans

epsilon=bredde/B;%Perforeringsgrad spalte
deltat=-bredde/pi*log(sin(pi/2*epsilon));%endekorreksjon spalte

epsilon2=bredde2/B2;%Perforeringsgrad lekkasje
deltat2=-bredde2/pi*log(sin(pi/2*epsilon2));%endekorreksjon lekkasje

%Angir impedansen for spaltepanelene og kaviteten
% phiteller=0;
% for phi=0:pi/(90*pi):pi/2,
% if true==true,
%     phi=89;
% phiteller=phiteller+1;
    
Zcav=-j*Zair.*cot(d.*k);%Kavitetens impedans

%Beregner inngangsimpedansen for mikroslissepanelet
[Rslit Xslit] = spalteimpedans(t,bredde,B,w);
Zelslit=(Rslit+j.*Xslit);
%Beregner inngangsimpedansen for lekkasjepanelet
[Rleak Xleak] = spalteimpedans(t2,bredde2,B2,w);
% Rleak=1;
% Xleak=rhoair*(t2+deltat2)/bredde2;
Zelleak=(Rleak+j.*Xleak);

phi=0;
%Deklarer trykk
Pin=1;
P0=2*Pin;
P1=P0;
P2=P1.*exp(-j*k*d*cos(phi));

%phiteller=0;
%for phi=0:pi/20:pi/2


% phiteller=phiteller+1;
%Tilegner impedansene
Z1=Zelslit;
Z2=Zcav;
Z3=Zelleak;


%%%%%%%%% LSNING FRA SUPERPOSISJON%%%%%%%
TEMP1=Zair+Z1+Z2.*(Z3+Zair)./(Z2+Z3+Zair);
Ztemp3=Z2./(Z1+Zair+Z2);
TEMP23=Z3+(Z2.*(Z1+Zair)./(Z1+Z2+Zair))./Ztemp3;

% U1=P1./Ztemp1-P2./Ztemp2.*Ztemp3;
% Urms1=U1;
%%%%%%%%%%%%%%%%%%%%%%%%
% Z3=sqrt(1./(mu.*w))+j.*w.*t2/bredde2;
%Lsning 2 formelevaluator
% TEMP1=Z1+Zair+(Z3+Zair).*Z2./(Z3+Zair+Z2);
TEMP21=((Z1+Zair).*(Z3+Zair)./Z2)+Z3+2.*Zair+Z1;

%%%%TEMP2 
TEMPp2 = (Z1 + Zair + Z2).*(Z3 + Zair)./Z2 + Zair + Z1;


% Urms1=P1./abs(TEMP1)+P2./abs(TEMP2);
 U1=P1./TEMP1-P2./TEMPp2;
%%%%%%%%%%%%%%

Urms2=U1.*conj(U1);
% Urms2=Urms1.^2;
Wabs=real(Z1).*Urms2; %Absorbert effekt
Winn=Pin^2/Zair; %Tilgjengelig effekt
alpha=Wabs./Winn; %Absorpsjonsfaktor

ZALT=(Z1+Z2); %Ingen lekkasje

alphaALT=4*real(ZALT/Zair)./((1+real(ZALT/Zair)).^2+(imag(ZALT/Zair)).^2);

end


figure(1)
semilogx(f,alphaALT,'r:',f,alpha,'k-.')
legend('Tett bakrom',[num2str(lekkasje),'mm lekkasje'],'Location','NorthEast')
absorptionplotfix;
ylim([0 1.3])


% figure(2)
% semilogx(f,real(Z1)./Zair,'-',f,imag(Z1)./Zair,'-')
% legend('Re{Zslit}','Im{Zelslit}','Re{Zleak}','Location','BestOutside')
% xlim([100 5000])
% 
% figure(4)
% semilogx(f,imag(Z3)./Zair,'-',f,real(Z3)./Zair,'r-')
% legend('Im{Zleak}','Re{Zleak}','Location','BestOutside')
% xlim([100 5000])
   


  
