%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Dette scriptet beregner absorpsjonsfaktor fra resultatfiler fra
%Norsonic 8201 Real Time Analyser. 
%Inndata: Tomromsmling; Mling p prveflate;
%Utdata: Absorpsjonsfaktor til .mat fil.
%Scriptet benytter funksjonen hentetterklang.mat for  lese
%etterklangstider fra analysatorfilene.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
clear all
%%%%%%%%%%%%%%%%
savemodifier=0; % savemodifier=1, lagrer resultatene til .mat fil.
%%%%%%%%%%%%%%%%
V=267.67; %Volum av etterklangsrommet
% St=7.2; %Areal av aktuell testflate
St=4.39;%N KASSETTERT RAMME
% St=3*4.39;%TRE KASSETTERTE RAMMER
% St=6.962;
% St=7.14;
% St=7.84;

temp1=15.8; %Temperatur i tomromsmling
temp2=16.5; %Temperatur i aktuell mling

%Les inn en mleserie fra tekstfiler
tomlok='lekkasjemaling/ET2/'; %Tomromsmlinglokasjon
[Frek T1 T12]=hentetterklang([tomlok,'ETT'],0,29);%Laster tomromsmling.

malelok='../maleresultater/lekkasjemaling/ET2/';%Mleresultatslokasjon
malenavn='ET7';%Filstamme for enkeltmling
start=0;%startfil
slutt=29;%sluttfil
% %laster mleresultat for prveflate
[Frek T2 T22]=hentetterklang([malelok,malenavn],start,slutt);

cair1=(331+0.6*temp1);%Lydhastighet for tomromsmling
cair2=(331+0.6*temp2);%Lydhastighet for prveflatemling

A1=(55.3*V./(cair1.*T1));%Absorpsjonsareal tomromsmling
A2=(55.3*V./(cair2.*T2));%Absorpsjonsareal for prveflate tilstede
At=A2-A1;%differanse i absoprsjon

alphas=At/St;%Absorpsjonsfaktor per flateareal av prven

plotabs([malenavn,' : ',num2str(start),'-',num2str(slutt)],Frek,alphas);
if savemodifier==1,
savefile=['../absresultater/',malenavn,num2str(start),num2str(slutt),'.mat'];
% savefile=['../absresultater/et19099et20019CALC','.mat'];
save(savefile,'alphas','Frek','malenavn','start','slutt','T1','T2')
end
