%Funksjonen leser etterklangsverdier fra analysatorfilene fra Norsonic 840
%[F T30 T20] = hentetterklang(filstamme,fra,til)
%inputparametre:    filstamme,   fillokasjon
%                   fra,         startnummer for resultatfilserie
%                   til,         sluttnummer for resultatfilserie
%returnerer:        F,           frekvensvektor
%                   T20,         T20 etterklangsverdier
%                   T30,         T30 etterklangsverdier
%
%
function [F T30 T20] = hentetterklang(filstamme,fra,til)
%initierer variable
T201=0;
T301=0;
T202=0;
T302=0;
T20t=0;
T30t=0;
T20avg=0;
T30avg=0;
Nmalinger=0;


for filteller=fra:til,
    if filteller <10
fid = fopen(['../maleresultater/',filstamme,'-0',num2str(filteller),'.txt'],'r'); 
    else
     fid = fopen(['../maleresultater/',filstamme,'-',num2str(filteller),'.txt'],'r');    
    end

InputText=textscan(fid,'%s',34,'delimiter','\n'); %Hopper over tekst i resultatfila.

Intro=InputText{1};

res1=textscan(fid,'%n%n%n%s%s%n%n%s',21,'delimiter',', ');%Leser etterklangsverdier fra resultatfil

F=res1{1,1};

T201=T201+res1{1,2};%T20verdi fra kanal 1
T301=T301+res1{1,3};%T30verdi fra kanal 1
T202=T202+res1{1,6};%T20verdi fra kanal 2
T302=T302+res1{1,7};%T30verdi fra kanal 2
Nmalinger=Nmalinger+1;%Antall indviduelle mlinger

fid = fclose(fid);%Lukker resultatfil

end%filtellerslutt

%Beregner middel av absorpsjonsfaktoren
T20t=T201+T202;%Legger sammen verdier fra to mikrofoner
T30t=T301+T302;%Legger sammen verdier fra to mikrofoner
Nmalinger=2*Nmalinger;%Totalt antall mlinger

T20avg=T20t/Nmalinger;%Midler etterklangsverdiene fra alle enkeltmlinger
T30avg=T30t/Nmalinger;%Midler etterklangsverdiene fra alle enkeltmlinger

T20=T20avg;%T20 ut
T30=T30avg;%T30 ut


