%Scriptet estimerer relativt standardavvik for en mleserie og beregner fra etterklangsmlinger

clear all;
close all;
malelok='metallplater/';%Mleresultatslokasjon
malenavn='etm6';%Filstamme for enkeltmling
filstamme=[malelok,malenavn];
siste=29
for til=1:siste,
fra=1;%startfil
% til=3;%sluttfil


for filteller=fra:til,
    if filteller <10
fid = fopen(['../maleresultater/',filstamme,'-0',num2str(filteller),'.txt'],'r'); 
    else
     fid = fopen(['../maleresultater/',filstamme,'-',num2str(filteller),'.txt'],'r');    
    end

InputText=textscan(fid,'%s',34,'delimiter','\n'); %Hopper over tekst i resultatfila.

Intro=InputText{1};

res1=textscan(fid,'%n%n%n%s%s%n%n%s',21,'delimiter',', ');%Leser etterklangsverdier fra resultatfil

Frek=res1{1,1};
T30(:,filteller)=res1{1,3};%Kanal 1
Trel=res1{1,3};
T30(:,filteller+til)=res1{1,7}; %Kanal 2


% T301(filteller,:)=res1{1,3};%T30verdi fra kanal 1

fid = fclose(fid);%Lukker resultatfil

end%filtellerslutt

%Beregner standardavviket
for kk=1:length(Frek),
  standardavvik(kk,til)=std(T30(kk,:));
  snitt(kk,til)=mean(T30(kk,:))
  end

%Estimerer standardavviket
avviket(til,:)=sqrt((2.42+3.59/til)./(Frek.*T30(:,til)));
end

%Plot estimert og beregnet standardavvik
figure(2)
semilogx(Frek,standardavvik(:,2)./snitt(:,2),'k-*',Frek,standardavvik(:,siste)./snitt(:,siste),'k-o','Linewidth',1)
% title([num2str(kk),'  til = ',num2str(til)])
absorptionplotfix;
xlim([100 5000])
ylim([0 0.25])
ylabel('rel. avvik','Fontsize',14)
xlabel('Frekvens [Hz]','Fontsize',14)
set(gca,'Fontsize',12)
legend('6 mlinger','60 mlinger')

figure(3)
semilogx(Frek,avviket(2,:),'k-^',Frek,avviket(siste,:),'k-*','Linewidth',1)
% title([num2str(kk),'  til = ',num2str(til)])
absorptionplotfix;
xlim([100 5000])
ylim([0 0.15])
ylabel('rel. avvik','Fontsize',14)
xlabel('Frekvens [Hz]','Fontsize',14)
set(gca,'Fontsize',12)
legend('4 mlinger','60 mlinger')

figure(4)
 semilogx(Frek,standardavvik(:,siste)./snitt(:,siste),'k-o',Frek,avviket(siste,:),'k-*','Linewidth',1)
% semilogx(Frek,standardavvik(:,siste)./snitt,'k-o',Frek,avviket(siste,:),'k-*','Linewidth',1)
% title([num2str(kk),'  til = ',num2str(til)])
absorptionplotfix;
xlim([50 5000])
ylim([0 0.2])
ylabel('rel. avvik','Fontsize',14)
xlabel('Frekvens [Hz]','Fontsize',14)
set(gca,'Fontsize',12)
legend('60 mlinger, \epsilon/T_{60}','60 mlinger, estimert')
