%Funksjonen beregner impedansen for et system av distribuerte spalter
%function [R X] = spalteimpedans(t,bredde,B,w)
%innparametere
%bredde:        Spaltebredde
%t     :        Spaltedybde 
%B     :        senter-senter avstand
%w     :        vinkelfrekvensvektor 
%utdata
%R     :        Re{Zspalte}, realdelen av spalteimpedansen.
%X     :        Im{Zspalte}, imaginrdelen av spalteimpedansen.  

function [R X] = spalteimpedans(t,bredde,B,w)
% clear all;
% close all;
% cair=344;
% f=[100,125,160,200,250,315,400,500,630,800,1000,1250,1600,2000,2500,3150,4000,5000];%frekvensvektor
% w=2.*pi.*f;%vinkelfrekvensvektor
% k=w./cair;%blgetall
% t=1/1000;%foringsdybde i mm
% 

        
%     for bredde =0.0001:0.001:0.1
% if true==true,
% bredde=0.1;
% bredde=0.17/1000;
% B=200/1000;%senter-senter avstand mikroslisse

%Deklarerer fysiske parametere
rhoair=1.2;%lufttetthet
cair=344;%lydhastighet
mu=17.4*10^-6;%viskositetskoeffisient

epsilon=bredde/B;%Perforeringsgrad spalte
deltat=-bredde/pi*log(sin(pi/2*epsilon));%endekorreksjon spalte

%Beregner impedansen etter metode beskrevet av Vigran og Pettersen i 
%"The absorption of slotted panels revisited" Forum Akustikum 2005
kprim=sqrt(w.*rhoair/j/mu);
rhoeq=rhoair./(1-(tan(kprim.*bredde/2)./(kprim*bredde/2)));
Zprim=j*rhoeq*t.*w;
ZprimALT=j*rhoeq*(t+2*deltat).*w;
% Zprimrekke=12*mu*t/bredde^2+1/700*t*bredde^2*rhoair^2.*w.^2/mu+j*6/5.*w*rhoair*t;




Zspalte=(Zprim+j*rhoair*2*deltat.*w)./epsilon;%GITT I ARTIKKELEN
% Zspalte=(Zprim+j*rhoeq*2*deltat.*w)./epsilon;%spalteimpedans MED RHOEQ!
% Zspalte=ZprimALT./epsilon; %

R=real(Zspalte);
X=imag(Zspalte);

% figure(1)
% Zavvik=Zspalte-ZspalteALT;
% % semilogx(f,imag(Zspalte),'-o',f,imag(ZspalteALT),'--.');
% semilogx(f,imag(Zavvik));
% legend('Zspalte','Zspalte(t+\deltat t)')
% % semilogx(f,Zavvik,'k-',f(7),Zavvik(7),'o',f(13),Zavvik(13),'o')
% % legend('Zprim','Zprimrekke','Location','BestOutside')
% % legend(['Avvik for spaltebredde',num2str(bredde*1000),'mm'],'500Hz')
% title(['bredde = ',num2str(bredde)])
% % ylim([0 5000])
% xlim([100 5000])
% xlabel('Frekvens [Hz]')
% ylabel('avvik [ \Omega ]')
% grid on
%  end